/*
    cgi2rc - convert CGI input to rc shell (version 1.1)
    Copyright (C) 1999  James Carter <james@cs.york.ac.uk>
    http://www.jfc.cx/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

void
output(char *s, int *ind)
{
  char c,esc[3],ec;

  c=s[*ind];
  switch (c) {
  case '+':
    fputc(' ',stdout);
    break;
  case '%':
    strncpy(esc,&s[(*ind)+1],2);
    ec=(char)strtol(esc,NULL,16);
    fputc(ec,stdout);
    (*ind)+=2;
    if (ec=='\'') fputc('\'',stdout);
    break;
  case '\'':
    fputc('\'',stdout);
  default:
    fputc(c,stdout);
    break;
  }
}

int
main(int argc, char *argv[])
{
  char *p,*qs;
  int i;

  p=getenv("QUERY_STRING");
  if (p && !strlen(p)) p=NULL;
  if (!p) {
    int cl;
    char *cls;

    cls=getenv("CONTENT_LENGTH");
    if (!cls) exit(EXIT_SUCCESS);
    cl=atoi(cls);
    if (!cl) exit(EXIT_SUCCESS);
    p=calloc(cl+1,sizeof(char));
    if (!p) {
      fprintf(stderr,"%s: fatal error - alloc failed\n",argv[0]);
      exit(EXIT_FAILURE);
    }
    if (fread(p,sizeof(char),cl,stdin)<cl) {
      fprintf(stderr,"%s: fatal error - content short\n",argv[0]);
      exit(EXIT_FAILURE);
    }
  }
  if (!p) exit(EXIT_SUCCESS);
  qs=calloc(strlen(p)+1,sizeof(char));
  if (!qs) {
    fprintf(stderr,"%s: fatal error - alloc failed\n",argv[0]);
    exit(EXIT_FAILURE);
  }
  strcpy(qs,p);
  for(p=strtok(qs,"&");p;p=strtok(NULL,"&")) {
    printf("FORM_");
    for (i=0;p[i]&&p[i]!='=';i++) {
       output(p,&i);
    }
    if (p[i]) i++;
    fputc('=',stdout);
    fputc('\'',stdout);
    for (;p[i];i++) {
       output(p,&i);
    }
    fputc('\'',stdout);
    fputc('\n',stdout);
  }
  exit(EXIT_SUCCESS);
}
